//+------------------------------------------------------------------
//|                                         Trend Quality B indicator
//|                                                            mladen 
//|                                    
//| as Published in TASC 22:04 article
//| Trend Quality indicator" by David Sepiashvili
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     clrHotPink
#property indicator_color2     clrDeepSkyBlue
#property indicator_color3     clrGray
#property indicator_color4     clrSandyBrown
#property indicator_color5     clrDeepSkyBlue
#property indicator_width5     2
#property indicator_style1     STYLE_DOT
#property indicator_style2     STYLE_DOT
#property indicator_style3     STYLE_DOT
#property indicator_style4     STYLE_DOT

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame               = PERIOD_CURRENT;
extern int                TrendPeriod             =  14;
extern int                NoisePeriod             = 250;
extern double             CorrectionFactor        =   2;
extern int                FastLength              =   7;
extern int                SlowLength              =  15;
extern double             SignalMultiplier        =  15;
extern ENUM_APPLIED_PRICE Price                   = PRICE_CLOSE;
extern int                MinMaxPeriod            =  50;
extern double             LevelUp                 =  90;
extern double             LevelDown               =  10;
extern bool               Interpolate             = true;

//
//
//
//
//

double trendQ[];
double trendQSign[];
double levelUp[];
double levelMi[];
double levelDn[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,trendQSign);
   SetIndexBuffer(1, levelUp);
   SetIndexBuffer(2, levelMi);
   SetIndexBuffer(3, levelDn);  
   SetIndexBuffer(4,trendQ);
         SignalMultiplier = MathMax(SignalMultiplier,0);
           
         //
         //
         //
         //
         //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
            
   IndicatorShortName(timeFrameToString(TimeFrame)+" Trend quality B1 ("+TrendPeriod+","+NoisePeriod+","+DoubleToStr(CorrectionFactor,2)+","+FastLength+","+SlowLength+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double work[][7];
#define _price  0
#define _emaf   1
#define _emas   2
#define _sign   3
#define _cpc    4
#define _trend  5
#define _dt     6

//
//
//
//
//

int start()
{
   int i,k,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (returnBars) { trendQSign[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
         double alpha1 = 2.0 / (1.0+FastLength);
         double alpha2 = 2.0 / (1.0+SlowLength);
         
      //
      //
      //
      //
      //

      for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
      {
         work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         work[r][_emaf]  = work[r-1][_emaf]+alpha1*(work[r][_price]-work[r-1][_emaf]);
         work[r][_emas]  = work[r-1][_emas]+alpha2*(work[r][_price]-work[r-1][_emas]);
            double macd  = work[r][_emaf]-work[r][_emas];
                           work[r][_sign] = work[r-1][_sign];
                              if (macd>0) work[r][_sign] =  1;
                              if (macd<0) work[r][_sign] = -1;
                              if (SignalMultiplier>0) trendQSign[i] = work[r][_sign]*SignalMultiplier;
      
            //
            //
            //
            //
            //
      
            double change = MathAbs(work[r][_price]-work[r-1][_price]);
            if (work[r][_sign] != work[r-1][_sign])
               {
                  work[r][_cpc]   = 0;
                  work[r][_trend] = 0;
               }
            else
               {
                  work[r][_cpc]   = work[r][_sign]*change+work[r-1][_cpc];
                  work[r][_trend] = work[r][_cpc]*(1.0/TrendPeriod)+work[r-1][_trend]*(1.0-(1.0/TrendPeriod));
               }
            work[r][_dt] = (work[r][_cpc]-work[r][_trend])*(work[r][_cpc]-work[r][_trend]);
         
            //
            //
            //
            //
            //
         
            double avgDt = 0; for (k=0; k<NoisePeriod; k++) avgDt += work[r-k][_dt]; avgDt /= NoisePeriod;
            double noise = CorrectionFactor*MathSqrt(avgDt);
            double temp  = 1; 
               if((MathAbs(work[r][_trend])+noise)!=0) temp = MathAbs(work[r][_trend])+noise;
                     trendQ[i]  = 100.0*(work[r][_trend])/temp;
                     double valMin = trendQ[ArrayMinimum(trendQ,MinMaxPeriod,i)];
                     double valMax = trendQ[ArrayMaximum(trendQ,MinMaxPeriod,i)];
                     double range  = valMax-valMin;
                        levelUp[i] = valMin+range*LevelUp/100.0;
                        levelMi[i] = valMin+range*0.5;
                        levelDn[i] = valMin+range*LevelDown/100.0;
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,"returnBars",0,0)*TimeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         trendQSign[i] = iCustom(NULL,TimeFrame,indicatorFileName,"calculateValue",TrendPeriod,NoisePeriod,CorrectionFactor,FastLength,SlowLength,SignalMultiplier,Price,MinMaxPeriod,LevelUp,LevelUp,0,y);
         trendQ[i]     = iCustom(NULL,TimeFrame,indicatorFileName,"calculateValue",TrendPeriod,NoisePeriod,CorrectionFactor,FastLength,SlowLength,SignalMultiplier,Price,MinMaxPeriod,LevelUp,LevelUp,1,y);

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int m = 1; m < n; m++)
            {
               trendQ[i+m]     = trendQ[i]     + (trendQ[i+n]    -trendQ[i]    )*m/n;
               trendQSign[i+m] = trendQSign[i] + (trendQSign[i+n]-trendQSign[i])*m/n;
            }            
   }      
   return(0);         
         
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}